package pilas.test;

import pilas.modelo.Pila;

/**
 * Esta es una mplementación en java del algoritmo que evalúa la correspondencia
 * de limitadores
 * 
 * @author Libardo
 * 
 */
public class CorrespondeciaDelimitadores {

	public static void main(String[] args) {
		// Expresion válida
		String expresion = "asdf{ad()()[]}";
		System.out.println("Valida? " + verificarDelimitadores(expresion));
		expresion = "asdf{ad()()[]";// Expresion invalida, falta cerrar una }
		System.out.println("Valida? " + verificarDelimitadores(expresion));
	}

	/**
	 * Algoritmo que verifica la correspondencia de delimitadores: [] {} ()
	 * 
	 * @param expresion
	 *            expresion a evaluar
	 * @return true cuando es correcta, false en caso contrario
	 */
	public static boolean verificarDelimitadores(String expresion) {
		Pila<Character> pila = new Pila<Character>();

		for (int i = 0; i < expresion.length(); i++) {
			char c = expresion.charAt(i);
			if (c == '(' || c == '{' || c == '[') {
				pila.apilar(c);
			} else {
				switch (c) {
				case ')':
					if (pila.cima() == '(')
						pila.retirar();
					else
						return false;
					break;
				case '}':
					if (pila.cima() == '{')
						pila.retirar();
					else
						return false;
					break;
				case ']':
					if (pila.cima() == '[')
						pila.retirar();
					else
						return false;
				}
			}
		}
		if (pila.esVacia())
			return true;
		else
			return false;

	}
}
